int n=0;//counter
int N=80;//number of samples;
long G1;//Data for the shuffle
long G1post;//Post Shuffle data for finding magnitude.
long G2;//Data for the shuffle
long G2post;//Post Shuffle data for finding magnitude.

boolean post = false; //ready for post processing, after Goertel shffle is done.
long coeff;// coefficient stored as long then divided by 64 to avoid floating point math.
long magnitudepile[15]; //a sum of all previous magnitudes to create a quick average.
long peakdisp;
long peak[15];
float SAMPLING_RATE = 19230; //stored as float to make math work... must figure out someday
float TARGET_FREQUENCY = 2550; //same
long magnitude;//magnitude from the individual sample.
long limit = 40000; //sets the limit at which the engine cuts
int test;
int time;
int RPMtick = 0;
int RPMtrigger = 0;
int RPMcount;
int RPM;
int disp;
#include <LiquidCrystal.h>
LiquidCrystal lcd(8, 13, 9, 4, 5, 6, 7);
void setup()
{
  Serial.begin(9600);
  pinMode(3, INPUT);
  attachInterrupt(1, RPMCount, FALLING);
  pinMode(A1, OUTPUT);
  pinMode(A3, OUTPUT);
  digitalWrite(A1, LOW); //creates a handy ground for input
    digitalWrite(A3, HIGH); //creates a handy 5v source for input
  lcd.clear(); 
  lcd.begin(16, 2);
  lcd.setCursor(0,0); 
  lcd.print("Blue"); 
  lcd.setCursor(0, 1);
  lcd.print("Knock Box"); 

  
  coeff = (2.0 * cos((2.0 * PI * (N * (TARGET_FREQUENCY / SAMPLING_RATE))) / N))*64;
  cli();//diable interrupts
 
  //set up continuous sampling of analog pin 1 at 19.23kHz
 
  //clear ADCSRA and ADCSRB registers
  ADCSRA = 0;
  ADCSRB = 0;
  //ADMUX |= (1 << REFS0); //set reference voltage (original (1))
  //ADMUX |= (1 << MUX0); //sets input to analog 1
  //ADMUX |= (1 << ADLAR); //left align the ADC value- so we can read highest 8 bits from ADCH register only
  ADMUX = B01000010; // (REFS1 REFS0 ADLAR RESERVED MUX2 MUX1 MUX0) 
  //16mhz/13per conversion /
  
  ADCSRA |= (1 << ADPS2) | (1 << ADPS1);//set ADC clock with 64 prescaler 16mhz/64/13 
  ADCSRA |= (1 << ADATE); //enabble auto trigger
  ADCSRA |= (1 << ADIE); //enable interrupts when measurement complete
  ADCSRA |= (1 << ADEN); //enable ADC
  ADCSRA |= (1 << ADSC); //start ADC measurements
  
  sei();//enable interrupts
  
}

ISR(ADC_vect) {//triggered when new ADC value ready
  
 
  int high;//need to get the high and low registrys then combine them.
  int low;
  low = ADCL;
  high = ADCH;
  test = ((high << 8) | low);//test variable used earlier to test output. Remains as legacy
  RPMtick++;
  if  ( n < N)//if counter under total number of samples
  {
    
  long G0;//extra variable to allow for the shuffle
  
  G0 = ((coeff * G1) >> 6) - G2 + (test - 512);
  G2 = G1;
  G1 = G0;
  n++;
  }
  else
  {
   if (post==false) 
   {
   G1post = G1;
   G2post = G2;
  G1=0;
  G2=0;
  post=true;
  n=0;
   }
    
  }
 
  
}


void loop()
{
  int index;
  long magnitudeavg=0;//Average of aproximately 8 samples. It's a rolling average so there is some overlap.

if (post==true)
{
 time++;
magnitude=(G1post * G1post + G2post *G2post - G1post*((G2post*coeff) >> 6));//fast analysis. Could be put inside the interupt, but then would slow sampling down.

post=false;//sets up for next sample.

magnitudepile[RPM] = magnitudepile[RPM] - (magnitudepile[RPM] >> 5) + (magnitude)  ; //keeps the pile aprox 8 samples by adding the new sample and subtracting 1/8th of the total.
magnitudeavg = (magnitudepile[RPM] >> 15);// bitshift by 5 to get average, then by 10 more to drop number down to somehting reasonable.
if (RPMtick >1154)
{
  RPM= RPMcount;
  RPMcount = 0; 
  RPMtick=0;
  
}



if (magnitudeavg > peak[RPM])
{
 peak[RPM]=magnitudeavg; //sets a peak value for testing 
}

if (magnitudeavg > limit)
{
 
}




if (time > 500)
{//Serial.print("Mag"); Serial.println(magnitude);
  lcd.clear(); 
  lcd.setCursor(0,0); 
  lcd.print("Peak"); 
  lcd.print(peak[disp]);//351 current peak at >>15
  lcd.setCursor(10,0); 
  lcd.print("RPM "); 
  lcd.print(disp);
  //Serial.println(magnitude);
  //Serial.println(test);
  lcd.setCursor(0,1);
  lcd.print("Mag "); 
  lcd.print(magnitudeavg);
  lcd.setCursor(10,1); 
  lcd.print("RPM "); 
  lcd.print(RPM);
  disp++;
  
  if (disp>12)
  {disp=0;}
 
  time=0;
 
}






}


 
  
}

void RPMCount () //happens every time Trigger wheel sends pulse
{
 RPMtrigger++;//add one to the rpm stack 
 if (RPMtrigger > 29)
 {
   RPMtrigger=0;
   RPMcount++;
 }
 
}
